diff --git a/src/krb5pa-md5_fmt_plug.c b/src/krb5pa-md5_fmt_plug.c
index 3fb399f69a..ef4c1ae6d8 100644
--- a/src/krb5pa-md5_fmt_plug.c
+++ b/src/krb5pa-md5_fmt_plug.c
@@ -100,7 +100,7 @@ john_register_one(&fmt_mskrb5);
 
 // Second and third plaintext will be replaced in init() under --encoding=utf8
 static struct fmt_tests tests[] = {
-	{"$krb5pa$23$user$realm$$afcbe07c32c3450b37d0f2516354570fe7d3e78f829e77cdc1718adf612156507181f7daeb03b6fbcfe91f8346f3c0ae7e8abfe5", "John"},
+	{"$krb5pa$23$user$realm$salt$afcbe07c32c3450b37d0f2516354570fe7d3e78f829e77cdc1718adf612156507181f7daeb03b6fbcfe91f8346f3c0ae7e8abfe5", "John"},
 	{"$mskrb5$john$JOHN.DOE.MS.COM$02E837D06B2AC76891F388D9CC36C67A$2A9785BF5036C45D3843490BF9C228E8C18653E10CE58D7F8EF119D2EF4F92B1803B1451", "fr2beesgr"},
 	{"$mskrb5$user1$EXAMPLE.COM$08b5adda3ab0add14291014f1d69d145$a28da154fa777a53e23059647682eee2eb6c1ada7fb5cad54e8255114270676a459bfe4a", "openwall"},
 	{"$mskrb5$hackme$EXAMPLE.NET$e3cdf70485f81a85f7b59a4c1d6910a3$6e2f6705551a76f84ec2c92a9dd0fef7b2c1d4ca35bf1b02423359a3ecaa19bdf07ed0da", "openwall@123"},
@@ -191,18 +191,21 @@ static char *split(char *ciphertext, int index, struct fmt_main *self)
 
 	if (!strncmp(ciphertext, "$mskrb5$", 8)) {
 		char in[TOTAL_LENGTH + 1];
-		char *u, *r, *c, *t;
+		char *c, *t;
 
-		strnzcpy(in, ciphertext, sizeof(out));
+		strnzcpy(in, ciphertext, sizeof(in));
 
 		t = strrchr(in, '$'); *t++ = 0;
 		c = strrchr(in, '$'); *c++ = 0;
-		r = strrchr(in, '$'); *r++ = 0;
-		u = in + 8;
 
-		snprintf(out, sizeof(out), "$krb5pa$23$%s$%s$$%s%s", u, r, t, c);
-	} else
-		strnzcpy(out, ciphertext, sizeof(out));
+		snprintf(out, sizeof(out), "$krb5pa$23$$$$%s%s", t, c);
+	} else {
+		char *tc;
+
+		tc = strrchr(ciphertext, '$');
+
+		snprintf(out, sizeof(out), "$krb5pa$23$$$$%s", tc);
+	}
 
 	data = out + strlen(out) - 2 * (CHECKSUM_SIZE + TIMESTAMP_SIZE) - 1;
 	strlwr(data);
diff --git a/src/krb5pa-sha1_fmt_plug.c b/src/krb5pa-sha1_fmt_plug.c
index 36f1601a40..513544bcce 100644
--- a/src/krb5pa-sha1_fmt_plug.c
+++ b/src/krb5pa-sha1_fmt_plug.c
@@ -95,6 +95,7 @@ static struct fmt_tests tests[] = {
 	{"$krb5pa$18$user1$EXAMPLE.COM$$a3918bd0381107feedec8db0022bdf3ac56e534ed54d13c62a7013a47713cfc31ef4e7e572f912fa4164f76b335e588bf29c2d17b11c5caa", "openwall"},
 	{"$krb5pa$18$l33t$EXAMPLE.COM$$98f732b309a1d7ef2355a974842a32894d911e97150f5d57f248e1c2632fbd3735c5f156532ccae0341e6a2d779ca83a06021fe57dafa464", "openwall"},
 	{"$krb5pa$18$aduser$AD.EXAMPLE.COM$$64dfeee04be2b2e0423814e0df4d0f960885aca4efffe6cb5694c4d34690406071c4968abd2c153ee42d258c5e09a41269bbcd7799f478d3", "password@123"},
+	{"$krb5pa$18$aduser$AD.EXAMPLE.COM$$f94f755a8b4493d925094a4eb1cec630ac40411a14c9733a853516fe426637d9daefdedc0567e2bb5a83d4f89a0ad1a4b178662b6106c0ff", "password@12345678"},
 	{"$krb5pa$18$aduser$AD.EXAMPLE.COM$AD.EXAMPLE.COMaduser$f94f755a8b4493d925094a4eb1cec630ac40411a14c9733a853516fe426637d9daefdedc0567e2bb5a83d4f89a0ad1a4b178662b6106c0ff", "password@12345678"},
 	/* etype 17 hash obtained using MiTM etype downgrade attack */
 	{"$krb5pa$17$user1$EXAMPLE.COM$$c5461873dc13665771b98ba80be53939e906d90ae1ba79cf2e21f0395e50ee56379fbef4d0298cfccfd6cf8f907329120048fd05e8ae5df4", "openwall"},
@@ -335,12 +336,30 @@ static void set_key(char *key, int index)
 	saved_key[index][saved_key_length] = 0;
 }
 
+// 'user:$krb5pa$etype$user$realm$salt$timestamp+checksum'
 static char *split(char *ciphertext, int index, struct fmt_main *pFmt)
 {
 	static char out[TOTAL_LENGTH + 1];
+	char in[TOTAL_LENGTH + 1];
+	char salt[MAX_SALTLEN + 1];
 	char *data;
+	char *e, *u, *r, *s, *tc;
+
+	strnzcpy(in, ciphertext, sizeof(in));
+
+	tc = strrchr(in, '$'); *tc++ = 0;
+	s = strrchr(in, '$'); *s++ = 0;
+	r = strrchr(in, '$'); *r++ = 0;
+	u = strrchr(in, '$'); *u++ = 0;
+	e = in + 8;
+
+	/* Default salt is user.realm */
+	if (!*s) {
+		snprintf(salt, sizeof(salt), "%s%s", r, u);
+		s = salt;
+	}
+	snprintf(out, sizeof(out), "$krb5pa$%s$%s$%s$%s$%s", e, u, r, s, tc);
 
-	strnzcpy(out, ciphertext, sizeof(out));
 	data = out + strlen(out) - 2 * (CHECKSUM_SIZE + TIMESTAMP_SIZE) - 1;
 	strlwr(data);
 
